Bug 827808 - Review Request: python-larch - Python B-tree library
Review Request: python-larch - Python B-tree library
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Ben Boeckel
Fedora Extras Quality Assurance
:
Depends On: 827803 827804 827805 827806 827807
Blocks: 827810
  Show dependency treegraph
 
Reported: 2012-06-03 02:26 EDT by Michel Alexandre Salim
Modified: 2012-09-27 00:31 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-09-20 16:33:59 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
mathstuf: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Michel Alexandre Salim 2012-06-03 02:26:58 EDT
Spec URL: http://salimma.fedorapeople.org/specs/admin/python-larch.spec
SRPM URL: http://salimma.fedorapeople.org/specs/admin/python-larch-1.20120527-1.fc17.src.rpm
Description:
This is an implementation of particular kind of B-tree, based on
research by Ohad Rodeh. See "B-trees, Shadowing, and Clones" (copied
here with permission of author) for details on the data
structure. This is the same data structure that btrfs uses. Note that
my implementation is independent from the btrfs one, and might differ
from what the paper describes.

The distinctive feature of this B-tree is that a node is never
modified (sort-of). Instead, all updates are done by
copy-on-write. Among other things, this makes it easy to clone a tree,
and modify only the clone, while other processes access the original
tree. This is utterly wonderful for my backup application, and that's
the reason I wrote larch in the first place.

I have tried to keep the implementation generic and flexible, so that
you may use it in a variety of situations. For example, the tree
itself does not decide where its nodes are stored: you provide a class
that does that for it. I have two implementations of the NodeStore
class, one for in-memory and one for on-disk storage.

The tree attempts to guarantee this: all modifications you make will
be safely stored in the node store when the larch.Forest.commit method
is called. After that, unless you actually modify the committed tree
yourself, it will be safe from further modifications. (You need to
take care to create a new tree for further modifications, though.)

Fedora Account System Username: salimma
Comment 1 Ben Boeckel 2012-06-08 20:45:02 EDT
I'll take this.
Comment 2 Michel Alexandre Salim 2012-06-19 07:54:58 EDT
Fixed the %%check now that the updated version of CoverageTestRunner actually fails when test coverage is incomplete

Spec URL: http://salimma.fedorapeople.org/specs/admin/python-larch.spec
SRPM URL: http://salimma.fedorapeople.org/specs/admin/python-larch-1.20120527-2.fc17.src.rpm

Ben: ping?
Comment 3 Terje Røsten 2012-07-09 06:22:55 EDT
Hi Ben, could you please continue the process?
Comment 4 Ben Boeckel 2012-07-09 23:12:20 EDT
Sorry for the delay.



Package Review
==============

Key:
- = N/A
x = Pass
! = Fail
? = Not evaluated



==== Generic ====
[x]: MUST Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: MUST Package successfully compiles and builds into binary rpms on at
     least one supported primary architecture.
[x]: MUST %build honors applicable compiler flags or justifies otherwise.
[x]: MUST All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: MUST Buildroot is not present
     Note: Unless packager wants to package for EPEL5 this is fine
[x]: MUST Package contains no bundled libraries.
[x]: MUST Changelog in prescribed format.
[x]: MUST Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: Clean would be needed if support for EPEL is required
[x]: MUST Sources contain only permissible code or content.
[x]: MUST Each %files section contains %defattr if rpm < 4.4
     Note: Note: defattr macros not found. They would be needed for EPEL5
[x]: MUST Macros in Summary, %description expandable at SRPM build time.
[x]: MUST Package requires other packages for directories it uses.
[x]: MUST Package uses nothing in %doc for runtime.
[x]: MUST Package is not known to require ExcludeArch.
[x]: MUST Permissions on files are set properly.
[x]: MUST Package does not contain duplicates in %files.
[x]: MUST Fully versioned dependency in subpackages, if present.
[x]: MUST Spec file lacks Packager, Vendor, PreReq tags.
[x]: MUST Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf would be needed if support for EPEL5 is required
[x]: MUST Large documentation files are in a -doc subpackage, if required.
[x]: MUST If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %doc.
[x]: MUST License field in the package spec file matches the actual license.
[x]: MUST License file installed when any subpackage combination is installed.
[x]: MUST Package consistently uses macros (instead of hard-coded directory
     names).
[x]: MUST Package is named according to the Package Naming Guidelines.
[x]: MUST Package does not generate any conflict.
[x]: MUST Package obeys FHS, except libexecdir and /usr/target.
[x]: MUST Package must own all directories that it creates.
[x]: MUST Package does not own files or directories owned by other packages.
[x]: MUST Package installs properly.
[x]: MUST Requires correct, justified where necessary.
[x]: MUST Rpmlint output is silent.

python-larch.noarch: W: spelling-error %description -l en_US btrfs -> barfs
python-larch.src: W: spelling-error %description -l en_US btrfs -> barfs
3 packages and 0 specfiles checked; 0 errors, 2 warnings.

[x]: MUST Sources used to build the package match the upstream source, as
     provided in the spec URL.
/home/boeckb/misc/code/review/827808/python-larch_1.20120527.orig.tar.gz :
  MD5SUM this package     : 9e67344022e4df72c3d56d641152fc29
  MD5SUM upstream package : 9e67344022e4df72c3d56d641152fc29

[x]: MUST Spec file is legible and written in American English.
[x]: MUST Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[-]: MUST Package contains a SysV-style init script if in need of one.
[x]: MUST File names are valid UTF-8.
[-]: MUST Useful -debuginfo package or justification otherwise.
[x]: SHOULD Reviewer should test that the package builds in mock.
[x]: SHOULD If the source package does not include license text(s) as a
     separate file from upstream, the packager SHOULD query upstream to
     include it.
[x]: SHOULD Dist tag is present.
[x]: SHOULD No file requires outside of /etc, /bin, /sbin, /usr/bin,
     /usr/sbin.
[x]: SHOULD Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[x]: SHOULD Package functions as described.
[x]: SHOULD Latest version is packaged.
[x]: SHOULD Package does not include license text files separate from
     upstream.
[x]: SHOULD SourceX is a working URL.
[-]: SHOULD Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[-]: SHOULD Package should compile and build into binary rpms on all supported
     architectures.
[x]: SHOULD %check is present and all tests pass.
[x]: SHOULD Packages should try to preserve timestamps of original installed
     files.
[x]: SHOULD Spec use %global instead of %define.


Generated by fedora-review 0.1.3
External plugins:

APPROVED
Comment 5 Michel Alexandre Salim 2012-09-15 06:10:01 EDT
Thanks, sorry for the delay on this side too.

New Package SCM Request
=======================
Package Name: python-larch
Short Description: Python B-tree library
Owners: salimma
Branches: el6 f16 f17 f18
InitialCC:
Comment 6 Gwyn Ciesla 2012-09-15 10:49:06 EDT
Git done (by process-git-requests).
Comment 7 Fedora Update System 2012-09-16 01:02:53 EDT
python-larch-1.20120527-3.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/python-larch-1.20120527-3.fc17
Comment 8 Fedora Update System 2012-09-16 01:03:04 EDT
python-larch-1.20120527-3.fc16 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/python-larch-1.20120527-3.fc16
Comment 9 Fedora Update System 2012-09-16 01:03:14 EDT
python-larch-1.20120527-3.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/python-larch-1.20120527-3.fc18
Comment 10 Fedora Update System 2012-09-16 15:19:22 EDT
python-larch-1.20120527-3.fc18 has been pushed to the Fedora 18 testing repository.
Comment 11 Fedora Update System 2012-09-20 16:33:59 EDT
python-larch-1.20120527-3.fc18 has been pushed to the Fedora 18 stable repository.
Comment 12 Fedora Update System 2012-09-27 00:29:49 EDT
python-larch-1.20120527-3.fc17 has been pushed to the Fedora 17 stable repository.
Comment 13 Fedora Update System 2012-09-27 00:31:45 EDT
python-larch-1.20120527-3.fc16 has been pushed to the Fedora 16 stable repository.

Note You need to log in before you can comment on or make changes to this bug.